#property copyright   "tomhliles@yahoo.com"
#property link        "tomhliles@yahoo.com"

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4
extern string default_gbpjpy_m15=     "//////for optimised psar- m5- most pairs";
extern bool         use_optimised_psar = False;
extern double       Maximum_Risk = 3;
extern double       Lots = 0.01;
  bool         normal_entry = True;
extern bool         trade_at_cross_only = True;
extern bool         EachTickMode  = True;
 bool         enter_at_ma = False;
 int          ma=30;
 extern string for_entry="//////entry options";
extern bool         open_with_psar = True;
extern bool         open_with_envelopes = False;
extern string for_exit=          "//////exit options";
extern bool         close_with_psar = True;
extern bool         close_with_envelopes = False;
extern string parabolic_sar=     "//////parabolic stop and reverse";
extern double       psar = 0.006;
extern double       max = 0.2;
extern int          time_frame_for_signal=0;
extern string envelope_settings=  "//////envelopes";
extern int          envelopes_period_buy = 15;
extern double       buy = 0.01;
extern double       close_buy = 0.2;


extern int          envelopes_period_sell = 15;
extern double       sell = 0.01;
extern double       close_sell = 0.2;
extern int          time_frame_for_env=0;

extern string other_exit_options= "//////";
extern int          BreakEven = 2000;
extern int          StopLoss        = 2000;   
extern int          TakeProfit      = 2000;   
extern int          TrailingStop    = 2000;

extern string trading_time= "//////";
extern bool         UseHourTrade = False;
extern int          FromHourTrade = 0;
extern int          ToHourTrade = 24;

extern string broker_options= "auto will detect max lots by broker";
extern bool         auto_max_lots_allowed = true;
extern double       Max_Lots_allowed    = 50; 
extern bool         normal_account = False;

extern string alerts= "notification options";
extern bool         Use_popup_and_sound_alert = True;
extern bool         Use_Sound_only = True;
extern bool         email_notification     = False; 

string              Message = "new alert from trendchaser psar";
string              NameFileSound = "alert.wav";
extern string miscelaneouse= "";
extern bool         comments = True;
extern bool         auto_magic_number = True;
extern int          MagicNumber  = 20;



string              automode = "none";
string              mode = "none";
string              tick_mode = "none";
string              mode_for_entry = "none";
string              mode_for_exit = "none";
string              Password = "trendchaser";
 string       swap  = "2=buy 0=sell 1=no trade";
 double       swap_direction = 1;
bool         swap_direction_only = False;
  double       Dis_Mm_If_Lots_Under  = 0.01;
double       mm  = 5000.0;
 double       lots_increase_when_losing = 0;
 int          losses_without_a_break    = 0;
bool   TradeAllowed=true; 
datetime bartime=1;                          // used to determine when a bar has moved
int      bartick=0;                          // number of times bars have moved

int BarCount;
int Current;
bool TickCheck = False;
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();
   int    losses=losses_without_a_break;
   lot=NormalizeDouble(AccountFreeMargin()*Maximum_Risk/mm,10);
   if(lots_increase_when_losing>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot+lot+losses/lots_increase_when_losing,2);
     }
   if(lot<Dis_Mm_If_Lots_Under) lot=Lots;
   if(lot> Max_Lots_allowed) lot=Max_Lots_allowed;
   return(lot);
  }
int init() {
   BarCount = Bars;
   if (EachTickMode) Current = 0; else Current = 1;
   return(0);
}
int deinit() {
   return(0);
}
int start()
  { 
  if(OrderSymbol()==Symbol() && OrderType()==OP_BUY){
            if(High[0]-OrderOpenPrice()>=BreakEven*Point && OrderStopLoss()!=OrderOpenPrice()){
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
               
            }   
         }   
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELL){
            if(OrderOpenPrice()-Low[0]>=BreakEven*Point && OrderStopLoss()!=OrderOpenPrice()){
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
               
               
           
     }
   }
  static bool ITradedOnThisBar;
  int      OrdersPerSymbol=0;
  int      cnt=0;
  if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      bartick++; 
      OrdersPerSymbol=0;
      for(cnt=OrdersTotal();cnt>=0;cnt--)
        {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) OrdersPerSymbol++;
        } 

      // this allows only one trade per bar preventing
      // lots of trades on big, single bar news moves
      if(OrdersPerSymbol==0) TradeAllowed=true;
     }
     if (normal_account){
   Dis_Mm_If_Lots_Under  = 0.1;

   mm  = 10000.0;
     {

     }
   }
if (use_optimised_psar){
   automode ="on";
     {

     }
   }
   if (use_optimised_psar==false){
   automode ="off";
     {

     }
   }
   if (close_with_envelopes&&close_with_psar){
   mode_for_exit ="psar envelopes";
     {

     }
   }
   if (close_with_envelopes==false&&close_with_psar){
   mode_for_exit ="psar";
     {

     }
   }
   if (close_with_envelopes&&close_with_psar==false){
   mode_for_exit ="envelopes";
     {

     }
   }
     //////////////////////////////////////
     if (open_with_envelopes&&open_with_psar&&enter_at_ma){
   mode_for_entry ="psar envelopes ma";
     {

     }
   }
   if (open_with_envelopes==false&&open_with_psar&&enter_at_ma){
   mode_for_entry ="psar ma";
     {

     }
   }
   if (open_with_envelopes&&open_with_psar==false&&enter_at_ma){
   mode_for_entry ="envelopes ma";
     {

     }
   }
   if (open_with_envelopes&&open_with_psar&&enter_at_ma==false){
   mode_for_entry ="psar envelopes";
     {

     }
   }
   if (open_with_envelopes==false&&open_with_psar&&enter_at_ma==false){
   mode_for_entry ="psar";
     {

     }
   }
   if (open_with_envelopes&&open_with_psar==false&&enter_at_ma==false){
   mode_for_entry ="envelopes";
     {

     }
   }
   if (trade_at_cross_only){
   mode ="trade at cross only";
     {

     }
   }
   if (enter_at_ma){
   mode ="enter at ma";
     {

     }
   }
   if (trade_at_cross_only==false){
   mode ="normal entry";
     {

     }
   }
   /////////////////////////////////
      if (trade_at_cross_only&&enter_at_ma||normal_entry){
   mode ="ERROR MORE THAN ONE ENTRY MODE IS SELECTED";
     {

     }
   }
   if (enter_at_ma&&trade_at_cross_only||normal_entry){
   mode ="ERROR MORE THAN ONE ENTRY MODE IS SELECTED";
     {

     }
   }
   if (normal_entry&&trade_at_cross_only||enter_at_ma){
   mode ="ERROR MORE THAN ONE ENTRY MODE IS SELECTED";
     {

     }
   }
  ///////////////////////////////////////////////////////////
   
   if (EachTickMode==False){
   tick_mode ="OFF";
     {

     }
   }
   if (EachTickMode){
   tick_mode ="ON";
     {

     }
   }
  if (UseHourTrade){
   if((Hour()>=FromHourTrade)&&(Hour()<=ToHourTrade))
      Comment("Trading Hours");
   else
     {
      Comment("Non-trading Hours");
      return(0);
     }
   }
 // bool demo_account = IsDemo();                                                                    //demo
   
 //  if (!demo_account)
 //  {
 //     Alert ("You can not use the program with a real account!"); 
 //     return(0);
  // }
  //int hard_accnt = 12345;                                                                           //<-- type the user account here before compiling
  //int accnt = AccountNumber();
  // if (accnt != hard_accnt)
   //{
     // Alert ("You can not use this account (" + DoubleToStr(accnt,0) + ") with this program!"); 
     // return(0);
   //}
//string expire_date = "2008.03.01";                                                                  //<-- hard coded datetime yr/month/day
 //  datetime e_d = StrToTime(expire_date); 
   
  // if (CurTime() >= e_d)
  // {
   //   Alert ("The trial version has expired!"); 
    //  return(0);
   //}
//if (Password != "trendchaser")                                                                           //change to the password you give the user!
    //{
     //   Alert ("Wrong password!");
     //   return (0);  
   // }
      int Leverage=AccountLeverage(); 
   double Balance=AccountBalance(); 
   double FreeMargin=AccountFreeMargin();
    double profit=AccountProfit();
    double equity=AccountEquity();
                double    SWAPLONG=MarketInfo("GBPJPYm",MODE_SWAPLONG);
   double    SWAPSHORT=MarketInfo("GBPJPYm",MODE_SWAPSHORT);
   int    MAXLOT=MarketInfo("GBPJPYm",MODE_MAXLOT);
   int    spread=MarketInfo("GBPJPYm",MODE_SPREAD);
            double    SWAPLONG1=MarketInfo("GBPUSDm",MODE_SWAPLONG);
   double    SWAPSHORT1=MarketInfo("GBPUSDm",MODE_SWAPSHORT);
   int    MAXLOT1=MarketInfo("GBPUSDm",MODE_MAXLOT);
   int    spread1=MarketInfo("GBPUSDm",MODE_SPREAD);
            double    SWAPLONG2=MarketInfo("EURUSDm",MODE_SWAPLONG);
   double    SWAPSHORT2=MarketInfo("EURUSDm",MODE_SWAPSHORT);
   int    MAXLOT2=MarketInfo("EURUSDm",MODE_MAXLOT);
   int    spread2=MarketInfo("EURUSDm",MODE_SPREAD);
            double    SWAPLONG3=MarketInfo("USDJPYm",MODE_SWAPLONG);
   double    SWAPSHORT3=MarketInfo("USDJPYm",MODE_SWAPSHORT);
   int    MAXLOT3=MarketInfo("USDJPYm",MODE_MAXLOT);
   int    spread3=MarketInfo("USDJPYm",MODE_SPREAD);
                     double    SWAPLONG4=MarketInfo("USDCHFm",MODE_SWAPLONG);
   double    SWAPSHORT4=MarketInfo("USDCHFm",MODE_SWAPSHORT);
   int    MAXLOT4=MarketInfo("USDCHFm",MODE_MAXLOT);
   int    spread4=MarketInfo("USDCHFm",MODE_SPREAD);
                     double    SWAPLONG5=MarketInfo("EURCHFm",MODE_SWAPLONG);
   double    SWAPSHORT5=MarketInfo("EURCHFm",MODE_SWAPSHORT);
   int    MAXLOT5=MarketInfo("EURCHFm",MODE_MAXLOT);
   int    spread5=MarketInfo("EURCHFm",MODE_SPREAD);
            double    SWAPLONG6=MarketInfo("AUDUSDm",MODE_SWAPLONG);
   double    SWAPSHORT6=MarketInfo("AUDUSDm",MODE_SWAPSHORT);
   int    MAXLOT6=MarketInfo("AUDUSDm",MODE_MAXLOT);
   int    spread6=MarketInfo("AUDUSDm",MODE_SPREAD);
                     double    SWAPLONG7=MarketInfo("USDCADm",MODE_SWAPLONG);
   double    SWAPSHORT7=MarketInfo("USDCADm",MODE_SWAPSHORT);
   int    MAXLOT7=MarketInfo("USDCADm",MODE_MAXLOT);
   int    spread7=MarketInfo("USDCADm",MODE_SPREAD);
                     double    SWAPLONG8=MarketInfo("NZDUSDm",MODE_SWAPLONG);
   double    SWAPSHORT8=MarketInfo("NZDUSDm",MODE_SWAPSHORT);
   int    MAXLOT8=MarketInfo("NZDUSDm",MODE_MAXLOT);
   int    spread8=MarketInfo("NZDUSDm",MODE_SPREAD);
                     double    SWAPLONG9=MarketInfo("EURGBPm",MODE_SWAPLONG);
   double    SWAPSHORT9=MarketInfo("EURGBPm",MODE_SWAPSHORT);
   int    MAXLOT9=MarketInfo("EURGBPm",MODE_MAXLOT);
   int    spread9=MarketInfo("EURGBPm",MODE_SPREAD);
                     double    SWAPLONG11=MarketInfo("EURJPYm",MODE_SWAPLONG);
   double    SWAPSHORT11=MarketInfo("EURJPYm",MODE_SWAPSHORT);
   int    MAXLOT11=MarketInfo("EURJPYm",MODE_MAXLOT);
   int    spread11=MarketInfo("EURJPYm",MODE_SPREAD);
                     double    SWAPLONG12=MarketInfo("CHFJPYm",MODE_SWAPLONG);
   double    SWAPSHORT12=MarketInfo("CHFJPYm",MODE_SWAPSHORT);
   int    MAXLOT12=MarketInfo("CHFJPYm",MODE_MAXLOT);
   int    spread12=MarketInfo("CHFJPYm",MODE_SPREAD);
                     double    SWAPLONG13=MarketInfo("GBPCHFm",MODE_SWAPLONG);
   double    SWAPSHORT13=MarketInfo("GBPCHFm",MODE_SWAPSHORT);
   int    MAXLOT13=MarketInfo("GBPCHFm",MODE_MAXLOT);
   int    spread13=MarketInfo("GBPCHFm",MODE_SPREAD);
                     double    SWAPLONG14=MarketInfo("EURAUDm",MODE_SWAPLONG);
   double    SWAPSHORT14=MarketInfo("EURAUDm",MODE_SWAPSHORT);
   int    MAXLOT14=MarketInfo("EURAUDm",MODE_MAXLOT);
   int    spread14=MarketInfo("EURAUDm",MODE_SPREAD);
                     double    SWAPLONG15=MarketInfo("EURCADm",MODE_SWAPLONG);
   double    SWAPSHORT15=MarketInfo("EURCADm",MODE_SWAPSHORT);
   int    MAXLOT15=MarketInfo("EURCADm",MODE_MAXLOT);
   int    spread15=MarketInfo("EURCADm",MODE_SPREAD);
                     double    SWAPLONG16=MarketInfo("AUDCADm",MODE_SWAPLONG);
   double    SWAPSHORT16=MarketInfo("AUDCADm",MODE_SWAPSHORT);
   int    MAXLOT16=MarketInfo("AUDCADm",MODE_MAXLOT);
   int    spread16=MarketInfo("AUDCADm",MODE_SPREAD);
                     double    SWAPLONG17=MarketInfo("AUDJPYm",MODE_SWAPLONG);
   double    SWAPSHORT17=MarketInfo("AUDJPYm",MODE_SWAPSHORT);
   int    MAXLOT17=MarketInfo("AUDJPYm",MODE_MAXLOT);
   int    spread17=MarketInfo("AUDJPYm",MODE_SPREAD);
                    double    SWAPLONG18=MarketInfo("NZDJPYm",MODE_SWAPLONG);
   double    SWAPSHORT18=MarketInfo("NZDJPYm",MODE_SWAPSHORT);
   int    MAXLOT18=MarketInfo("NZDJPYm",MODE_MAXLOT);
   int    spread18=MarketInfo("NZDJPYm",MODE_SPREAD);
            double    SWAPLONG19=MarketInfo("AUDNZDm",MODE_SWAPLONG);
   double    SWAPSHORT19=MarketInfo("AUDNZDm",MODE_SWAPSHORT);
   int    MAXLOT19=MarketInfo("AUDNZDm",MODE_MAXLOT);
   int    spread19=MarketInfo("AUDNZDm",MODE_SPREAD);
         double    nSWAPLONG=MarketInfo("GBPJPY",MODE_SWAPLONG);
   double    nSWAPSHORT=MarketInfo("GBPJPY",MODE_SWAPSHORT);
   int    nMAXLOT=MarketInfo("GBPJPY",MODE_MAXLOT);
   int    nspread=MarketInfo("GBPJPY",MODE_SPREAD);
            double    nSWAPLONG1=MarketInfo("GBPUSD",MODE_SWAPLONG);
   double    nSWAPSHORT1=MarketInfo("GBPUSD",MODE_SWAPSHORT);
   int    nMAXLOT1=MarketInfo("GBPUSD",MODE_MAXLOT);
   int    nspread1=MarketInfo("GBPUSD",MODE_SPREAD);
            double    nSWAPLONG2=MarketInfo("EURUSD",MODE_SWAPLONG);
   double    nSWAPSHORT2=MarketInfo("EURUSD",MODE_SWAPSHORT);
   int    nMAXLOT2=MarketInfo("EURUSD",MODE_MAXLOT);
   int    nspread2=MarketInfo("EURUSD",MODE_SPREAD);
            double    nSWAPLONG3=MarketInfo("USDJPY",MODE_SWAPLONG);
   double    nSWAPSHORT3=MarketInfo("USDJPY",MODE_SWAPSHORT);
   int    nMAXLOT3=MarketInfo("USDJPY",MODE_MAXLOT);
   int    nspread3=MarketInfo("USDJPY",MODE_SPREAD);
                     double    nSWAPLONG4=MarketInfo("USDCHF",MODE_SWAPLONG);
   double    nSWAPSHORT4=MarketInfo("USDCHF",MODE_SWAPSHORT);
   int    nMAXLOT4=MarketInfo("USDCHF",MODE_MAXLOT);
   int    nspread4=MarketInfo("USDCHF",MODE_SPREAD);
                     double    nSWAPLONG5=MarketInfo("EURCHF",MODE_SWAPLONG);
   double    nSWAPSHORT5=MarketInfo("EURCHF",MODE_SWAPSHORT);
   int    nMAXLOT5=MarketInfo("EURCHF",MODE_MAXLOT);
   int    nspread5=MarketInfo("EURCHF",MODE_SPREAD);
            double    nSWAPLONG6=MarketInfo("AUDUSD",MODE_SWAPLONG);
   double    nSWAPSHORT6=MarketInfo("AUDUSD",MODE_SWAPSHORT);
   int    nMAXLOT6=MarketInfo("AUDUSD",MODE_MAXLOT);
   int    nspread6=MarketInfo("AUDUSD",MODE_SPREAD);
                     double    nSWAPLONG7=MarketInfo("USDCAD",MODE_SWAPLONG);
   double    nSWAPSHORT7=MarketInfo("USDCAD",MODE_SWAPSHORT);
   int    nMAXLOT7=MarketInfo("USDCAD",MODE_MAXLOT);
   int    nspread7=MarketInfo("USDCAD",MODE_SPREAD);
                     double    nSWAPLONG8=MarketInfo("NZDUSD",MODE_SWAPLONG);
   double    nSWAPSHORT8=MarketInfo("NZDUSD",MODE_SWAPSHORT);
   int    nMAXLOT8=MarketInfo("NZDUSD",MODE_MAXLOT);
   int    nspread8=MarketInfo("NZDUSD",MODE_SPREAD);
                     double    nSWAPLONG9=MarketInfo("EURGBP",MODE_SWAPLONG);
   double    nSWAPSHORT9=MarketInfo("EURGBP",MODE_SWAPSHORT);
   int    nMAXLOT9=MarketInfo("EURGBP",MODE_MAXLOT);
   int    nspread9=MarketInfo("EURGBP",MODE_SPREAD);
                     double    nSWAPLONG11=MarketInfo("EURJPY",MODE_SWAPLONG);
   double    nSWAPSHORT11=MarketInfo("EURJPY",MODE_SWAPSHORT);
   int    nMAXLOT11=MarketInfo("EURJPY",MODE_MAXLOT);
   int    nspread11=MarketInfo("EURJPY",MODE_SPREAD);
                     double    nSWAPLONG12=MarketInfo("CHFJPY",MODE_SWAPLONG);
   double    nSWAPSHORT12=MarketInfo("CHFJPY",MODE_SWAPSHORT);
   int    nMAXLOT12=MarketInfo("CHFJPY",MODE_MAXLOT);
   int    nspread12=MarketInfo("CHFJPY",MODE_SPREAD);
                     double    nSWAPLONG13=MarketInfo("GBPCHF",MODE_SWAPLONG);
   double    nSWAPSHORT13=MarketInfo("GBPCHF",MODE_SWAPSHORT);
   int    nMAXLOT13=MarketInfo("GBPCHF",MODE_MAXLOT);
   int    nspread13=MarketInfo("GBPCHF",MODE_SPREAD);
                     double    nSWAPLONG14=MarketInfo("EURAUD",MODE_SWAPLONG);
   double    nSWAPSHORT14=MarketInfo("EURAUD",MODE_SWAPSHORT);
   int    nMAXLOT14=MarketInfo("EURAUD",MODE_MAXLOT);
   int    nspread14=MarketInfo("EURAUD",MODE_SPREAD);
                     double    nSWAPLONG15=MarketInfo("EURCAD",MODE_SWAPLONG);
   double    nSWAPSHORT15=MarketInfo("EURCAD",MODE_SWAPSHORT);
   int    nMAXLOT15=MarketInfo("EURCAD",MODE_MAXLOT);
   int    nspread15=MarketInfo("EURCAD",MODE_SPREAD);
                     double    nSWAPLONG16=MarketInfo("AUDCAD",MODE_SWAPLONG);
   double    nSWAPSHORT16=MarketInfo("AUDCAD",MODE_SWAPSHORT);
   int    nMAXLOT16=MarketInfo("AUDCAD",MODE_MAXLOT);
   int    nspread16=MarketInfo("AUDCAD",MODE_SPREAD);
                     double    nSWAPLONG17=MarketInfo("AUDJPY",MODE_SWAPLONG);
   double    nSWAPSHORT17=MarketInfo("AUDJPY",MODE_SWAPSHORT);
   int    nMAXLOT17=MarketInfo("AUDJPY",MODE_MAXLOT);
   int    nspread17=MarketInfo("AUDJPY",MODE_SPREAD);
                    double    nSWAPLONG18=MarketInfo("NZDJPY",MODE_SWAPLONG);
   double    nSWAPSHORT18=MarketInfo("NZDJPY",MODE_SWAPSHORT);
   int    nMAXLOT18=MarketInfo("NZDJPY",MODE_MAXLOT);
   int    nspread18=MarketInfo("NZDJPY",MODE_SPREAD);
            double    nSWAPLONG19=MarketInfo("AUDNZD",MODE_SWAPLONG);
   double    nSWAPSHORT19=MarketInfo("AUDNZD",MODE_SWAPSHORT);
   int    nMAXLOT19=MarketInfo("AUDNZD",MODE_MAXLOT);
   int    nspread19=MarketInfo("AUDNZDm",MODE_SPREAD);
           if (use_optimised_psar&&normal_account){                               //FGBPJPYm 
        if (Symbol()=="GBPJPY"){

psar = 0.00038;
max = 0.011;
time_frame_for_signal=5;
      }   
      else if (Symbol()=="GBPUSD"){                                 //FGBPUSDm

psar = 0.00041;
max = 0.011;
time_frame_for_signal=5;
               }   
      else if (Symbol()=="EURUSD"){                     //FEURUSDm
psar = 0.00058;
max = 0.011;
time_frame_for_signal=5;

                        }   
      else if (Symbol()=="USDJPY"){                     //FUSDJPYm
psar = 0.0002;
max = 0.008;

time_frame_for_signal=5;
                                 }   
      else if (Symbol()=="USDCHF"){                          //FUSDCHFm
psar = 0.00031;
max = 0.007;
time_frame_for_signal=15;

                                 }   
      else if (Symbol()=="EURCHF"){                              //FEURCHFm
psar = 0.00041;
max = 0.008;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="AUDUSD"){                        //FAUDUSDm
psar = 0.00033;
max = 0.008;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="USDCAD"){                    //FUSDCADm
psar = 0.00088;
max = 0.008;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="NZDUSD"){                  //FNZDUSDm
psar = 0.0001;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURGBP"){                       //FEURGBPm
psar = 0.00019;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURJPY"){                         //FEURJPYm
psar = 0.00052;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="CHFJPY"){                           //FCHFJPYm
psar = 0.00036;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="GBPCHF"){                     //FGBPCHFm
psar = 0.00054;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURAUD"){                       //FEURAUDm
psar = 0.00036;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURCAD"){                            //FEURCADm
psar = 0.00014;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="AUDCAD"){                        //FAUDCADm
psar = 0.0000;
max = 0.000;
time_frame_for_signal=0;

                                 }   
      else if (Symbol()=="AUDJPY"){                        //FAUDJPYm
psar = 0.000;
time_frame_for_signal=0;

                                 }   
      else if (Symbol()=="NZDJPY"){                        //FNZDJPYm
psar = 0.0000;
time_frame_for_signal=0;

                                 }   
      else if (Symbol()=="AUDNZD"){                         //FAUDNZDm
psar = 0.0000;
time_frame_for_signal=0;

      }
      else {
psar = 0.0000;
time_frame_for_signal=0;
      }
   } 
        if (use_optimised_psar&&normal_account==false){                               //FGBPJPYm 
        if (Symbol()=="GBPJPYm"){

psar = 0.00038;
max = 0.011;
time_frame_for_signal=5;
      }   
      else if (Symbol()=="GBPUSDm"){                                 //FGBPUSDm

psar = 0.00041;
max = 0.011;
time_frame_for_signal=5;
               }   
      else if (Symbol()=="EURUSDm"){                     //FEURUSDm
psar = 0.00058;
max = 0.011;
time_frame_for_signal=5;

                        }   
      else if (Symbol()=="USDJPYm"){                     //FUSDJPYm
psar = 0.0002;
max = 0.008;

time_frame_for_signal=5;
                                 }   
      else if (Symbol()=="USDCHFm"){                          //FUSDCHFm
psar = 0.00031;
max = 0.007;
time_frame_for_signal=15;

                                 }   
      else if (Symbol()=="EURCHFm"){                              //FEURCHFm
psar = 0.00041;
max = 0.008;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="AUDUSDm"){                        //FAUDUSDm
psar = 0.00033;
max = 0.008;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="USDCADm"){                    //FUSDCADm
psar = 0.00088;
max = 0.008;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="NZDUSDm"){                  //FNZDUSDm
psar = 0.0001;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURGBPm"){                       //FEURGBPm
psar = 0.00019;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURJPYm"){                         //FEURJPYm
psar = 0.00052;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="CHFJPYm"){                           //FCHFJPYm
psar = 0.00036;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="GBPCHFm"){                     //FGBPCHFm
psar = 0.00054;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURAUDm"){                       //FEURAUDm
psar = 0.00036;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="EURCADm"){                            //FEURCADm
psar = 0.00014;
max = 0.005;
time_frame_for_signal=5;

                                 }   
      else if (Symbol()=="AUDCADm"){                        //FAUDCADm
psar = 0.0000;
max = 0.000;
time_frame_for_signal=0;

                                 }   
      else if (Symbol()=="AUDJPYm"){                        //FAUDJPYm
psar = 0.000;
time_frame_for_signal=0;

                                 }   
      else if (Symbol()=="NZDJPYm"){                        //FNZDJPYm
psar = 0.0000;
time_frame_for_signal=0;

                                 }   
      else if (Symbol()=="AUDNZDm"){                         //FAUDNZDm
psar = 0.0000;
time_frame_for_signal=0;

      }
      else {
psar = 0.0000;
time_frame_for_signal=0;
      }
   } 
       if (auto_max_lots_allowed&&normal_account==false){                               //FGBPJPYm 
        if (Symbol()=="GBPJPYm"){
Max_Lots_allowed     = MAXLOT;

      }   
      else if (Symbol()=="GBPUSDm"){                                 //FGBPUSDm
Max_Lots_allowed     = MAXLOT1;

               }   
      else if (Symbol()=="EURUSDm"){                     //FEURUSDm

Max_Lots_allowed     = MAXLOT2;
                        }   
      else if (Symbol()=="USDJPYm"){                     //FUSDJPYm

Max_Lots_allowed     = MAXLOT3;                         }   
      else if (Symbol()=="USDCHFm"){                          //FUSDCHFm

Max_Lots_allowed     = MAXLOT4;
                                 }   
      else if (Symbol()=="EURCHFm"){                              //FEURCHFm

Max_Lots_allowed     = MAXLOT5;
                                 }   
      else if (Symbol()=="AUDUSDm"){                        //FAUDUSDm

Max_Lots_allowed     = MAXLOT6;
                                 }   
      else if (Symbol()=="USDCADm"){                    //FUSDCADm

Max_Lots_allowed     = MAXLOT7;
                                 }   
      else if (Symbol()=="NZDUSDm"){                  //FNZDUSDm

Max_Lots_allowed     = MAXLOT8;
                                 }   
      else if (Symbol()=="EURGBPm"){                       //FEURGBPm

Max_Lots_allowed     = MAXLOT9;
                                 }   
      else if (Symbol()=="EURJPYm"){                         //FEURJPYm

Max_Lots_allowed     = MAXLOT11;
                                 }   
      else if (Symbol()=="CHFJPYm"){                           //FCHFJPYm

Max_Lots_allowed     = MAXLOT12;
                                 }   
      else if (Symbol()=="GBPCHFm"){                     //FGBPCHFm

Max_Lots_allowed     = MAXLOT13;
                                 }   
      else if (Symbol()=="EURAUDm"){                       //FEURAUDm

Max_Lots_allowed     = MAXLOT14;
                                 }   
      else if (Symbol()=="EURCADm"){                            //FEURCADm

Max_Lots_allowed     = MAXLOT15;
                                 }   
      else if (Symbol()=="AUDCADm"){                        //FAUDCADm

Max_Lots_allowed     = MAXLOT16;
                                 }   
      else if (Symbol()=="AUDJPYm"){                        //FAUDJPYm

Max_Lots_allowed     = MAXLOT17;
                                 }   
      else if (Symbol()=="NZDJPYm"){                        //FNZDJPYm

Max_Lots_allowed     = MAXLOT18;
                                 }   
      else if (Symbol()=="AUDNZDm"){                         //FAUDNZDm

Max_Lots_allowed     = MAXLOT19;
      }
      else {

      }
   } 
   if (auto_max_lots_allowed&&normal_account){                               //FGBPJPYm 
        if (Symbol()=="GBPJPY"){
Max_Lots_allowed     = nMAXLOT;

      }   
      else if (Symbol()=="GBPUSD"){                                 //FGBPUSDm
Max_Lots_allowed     = nMAXLOT1;

               }   
      else if (Symbol()=="EURUSD"){                     //FEURUSDm

Max_Lots_allowed     = nMAXLOT2;
                        }   
      else if (Symbol()=="USDJPY"){                     //FUSDJPYm

Max_Lots_allowed     = nMAXLOT3;
                                 }   
      else if (Symbol()=="USDCHF"){                          //FUSDCHFm

Max_Lots_allowed     = nMAXLOT4;
                                 }   
      else if (Symbol()=="EURCHF"){                              //FEURCHFm

Max_Lots_allowed     = nMAXLOT5;
                                 }   
      else if (Symbol()=="AUDUSD"){                        //FAUDUSDm

Max_Lots_allowed     = nMAXLOT6;
                                 }   
      else if (Symbol()=="USDCAD"){                    //FUSDCADm

Max_Lots_allowed     = nMAXLOT7;
                                 }   
      else if (Symbol()=="NZDUSD"){                  //FNZDUSDm

Max_Lots_allowed     = nMAXLOT8;
                                 }   
      else if (Symbol()=="EURGBP"){                       //FEURGBPm

Max_Lots_allowed     = nMAXLOT9;
                                 }   
      else if (Symbol()=="EURJPY"){                         //FEURJPYm

Max_Lots_allowed     = nMAXLOT11;
                                 }   
      else if (Symbol()=="CHFJPY"){                           //FCHFJPYm

Max_Lots_allowed     = nMAXLOT12;
                                 }   
      else if (Symbol()=="GBPCHF"){                     //FGBPCHFm

Max_Lots_allowed     = nMAXLOT13;
                                 }   
      else if (Symbol()=="EURAUD"){                       //FEURAUDm

Max_Lots_allowed     = nMAXLOT14;
                                 }   
      else if (Symbol()=="EURCAD"){                            //FEURCADm

Max_Lots_allowed     = nMAXLOT15;
                                 }   
      else if (Symbol()=="AUDCAD"){                        //FAUDCADm

Max_Lots_allowed     = nMAXLOT16;
                                 }   
      else if (Symbol()=="AUDJPY"){                        //FAUDJPYm

Max_Lots_allowed     = nMAXLOT17;
                                 }   
      else if (Symbol()=="NZDJPY"){                        //FNZDJPYm

Max_Lots_allowed     = nMAXLOT18;
                                 }   
      else if (Symbol()=="AUDNZD"){                         //FAUDNZDm

Max_Lots_allowed     = nMAXLOT19;
      }
      else {

      }
   } 
    if (auto_magic_number&&normal_account==false){                               //FGBPJPYm 
        if (Symbol()=="GBPJPYm"){

MagicNumber                = 201;
      }   
      else if (Symbol()=="GBPUSDm"){                                 //FGBPUSDm

MagicNumber                = 102;
               }   
      else if (Symbol()=="EURUSDm"){                     //FEURUSDm
MagicNumber                = 103;

                        }   
      else if (Symbol()=="USDJPYm"){                     //FUSDJPYm
MagicNumber                = 104;
                         }   
      else if (Symbol()=="USDCHFm"){                          //FUSDCHFm
MagicNumber                = 105;

                                 }   
      else if (Symbol()=="EURCHFm"){                              //FEURCHFm
MagicNumber                = 106;

                                 }   
      else if (Symbol()=="AUDUSDm"){                        //FAUDUSDm
MagicNumber                = 107;

                                 }   
      else if (Symbol()=="USDCADm"){                    //FUSDCADm
MagicNumber                = 108;

                                 }   
      else if (Symbol()=="NZDUSDm"){                  //FNZDUSDm
MagicNumber                = 109;

                                 }   
      else if (Symbol()=="EURGBPm"){                       //FEURGBPm
MagicNumber                = 110;

                                 }   
      else if (Symbol()=="EURJPYm"){                         //FEURJPYm
MagicNumber                = 111;

                                 }   
      else if (Symbol()=="CHFJPYm"){                           //FCHFJPYm
MagicNumber                = 112;

                                 }   
      else if (Symbol()=="GBPCHFm"){                     //FGBPCHFm
MagicNumber                = 113;

                                 }   
      else if (Symbol()=="EURAUDm"){                       //FEURAUDm
MagicNumber                = 114;

                                 }   
      else if (Symbol()=="EURCADm"){                            //FEURCADm
MagicNumber                = 115;

                                 }   
      else if (Symbol()=="AUDCADm"){                        //FAUDCADm
MagicNumber                = 116;

                                 }   
      else if (Symbol()=="AUDJPYm"){                        //FAUDJPYm
MagicNumber                = 117;

                                 }   
      else if (Symbol()=="NZDJPYm"){                        //FNZDJPYm
MagicNumber                = 118;

                                 }   
      else if (Symbol()=="AUDNZDm"){                         //FAUDNZDm
MagicNumber                = 119;

      }
      else {
MagicNumber                = 1020;
      }
   } 
   if (auto_magic_number&&normal_account){                               //FGBPJPYm 
        if (Symbol()=="GBPJPY"){

MagicNumber                = 101;
      }   
      else if (Symbol()=="GBPUSD"){                                 //FGBPUSDm

MagicNumber                = 102;
               }   
      else if (Symbol()=="EURUSD"){                     //FEURUSDm
MagicNumber                = 103;

                        }   
      else if (Symbol()=="USDJPY"){                     //FUSDJPYm
MagicNumber                = 104;

                                 }   
      else if (Symbol()=="USDCHF"){                          //FUSDCHFm
MagicNumber                = 105;

                                 }   
      else if (Symbol()=="EURCHF"){                              //FEURCHFm
MagicNumber                = 106;

                                 }   
      else if (Symbol()=="AUDUSD"){                        //FAUDUSDm
MagicNumber                = 107;

                                 }   
      else if (Symbol()=="USDCAD"){                    //FUSDCADm
MagicNumber                = 108;

                                 }   
      else if (Symbol()=="NZDUSD"){                  //FNZDUSDm
MagicNumber                = 109;

                                 }   
      else if (Symbol()=="EURGBP"){                       //FEURGBPm
MagicNumber                = 110;

                                 }   
      else if (Symbol()=="EURJPY"){                         //FEURJPYm
MagicNumber                = 111;

                                 }   
      else if (Symbol()=="CHFJPY"){                           //FCHFJPYm
MagicNumber                = 112;

                                 }   
      else if (Symbol()=="GBPCHF"){                     //FGBPCHFm
MagicNumber                = 113;

                                 }   
      else if (Symbol()=="EURAUD"){                       //FEURAUDm
MagicNumber                = 114;

                                 }   
      else if (Symbol()=="EURCAD"){                            //FEURCADm
MagicNumber                = 115;

                                 }   
      else if (Symbol()=="AUDCAD"){                        //FAUDCADm
MagicNumber                = 116;

                                 }   
      else if (Symbol()=="AUDJPY"){                        //FAUDJPYm
MagicNumber                = 117;

                                 }   
      else if (Symbol()=="NZDJPY"){                        //FNZDJPYm
MagicNumber                = 118;

                                 }   
      else if (Symbol()=="AUDNZD"){                         //FAUDNZDm
MagicNumber                = 119;

      }
      else {
MagicNumber                = 1020;
      }
   } 
   
         if (comments&&normal_account==false){                               //FGBPJPYm 
        if (Symbol()=="GBPJPYm"){

                                    swap_direction = 2;
                                    Message = "new alert GBPJPY ";
                                    



Comment("\n"," --***--TREND CHASER PSAR--***--GBPJPYm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",

"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
      }   
      else if (Symbol()=="GBPUSDm"){                                 //FGBPUSDm

                                 swap_direction = 2;
                                                                  Message = "new alert GBPUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--GBPUSDm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",

"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
               }   
      else if (Symbol()=="EURUSDm"){                     //FEURUSDm

         swap_direction = 0;
                  Message = "new alert EURUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURUSDm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                        }   
      else if (Symbol()=="USDJPYm"){                     //FUSDJPYm

         swap_direction = 2;
                  Message = "new alert USDJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--USDJPYm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="USDCHFm"){                          //FUSDCHFm

         swap_direction = 2;
                  Message = "new alert USDCHF ";
Comment("\n"," --***--TREND CHASER PSAR--***--USDCHFm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURCHFm"){                              //FEURCHFm

         swap_direction = 2;
                  Message = "new alert EURCHF ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURCHFm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDUSDm"){                        //FAUDUSDm

         swap_direction = 2;
                  Message = "new alert AUDUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDUSDm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="USDCADm"){                    //FUSDCADm

         swap_direction = 2;
                  Message = "new alert USDCAD ";
Comment("\n"," --***--TREND CHASER PSAR--***--USDCADm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="NZDUSDm"){                  //FNZDUSDm

         swap_direction = 2;
                  Message = "new alert NZDUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--NZDUSDm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURGBPm"){                       //FEURGBPm

         swap_direction = 0;
                  Message = "new alert EURGBP ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURGBPm  period ", Period(),(""),
"\n",
"\n","     optimised psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURJPYm"){                         //FEURJPYm

         swap_direction = 2;
                  Message = "new alert EURJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURJPYm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="CHFJPYm"){                           //FCHFJPYm

         swap_direction = 2;
                  Message = "new alert CHFJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--CHFJPYm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="GBPCHFm"){                     //FGBPCHFm

         swap_direction = 2;
                  Message = "new alert GBPCHF ";
Comment("\n"," --***--TREND CHASER PSAR--***--GBPCHFm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURAUDm"){                       //FEURAUDm

         swap_direction = 0;
                  Message = "new alert EURAUD "; 
Comment("\n"," --***--TREND CHASER PSAR--***--EURAUDm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURCADm"){                            //FEURCADm

         swap_direction = 0;
                  Message = "new alert EURCAD ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURCADm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDCADm"){                        //FAUDCADm

         swap_direction = 2;
                  Message = "new alert AUDCAD ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDCADm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDJPYm"){                        //FAUDJPYm

         swap_direction = 2;
                  Message = "new alert AUDJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDJPYm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="NZDJPYm"){                        //FNZDJPYm

         swap_direction = 2;
                           Message = "new alert FNZDJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--NZDJPYm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDNZDm"){                         //FAUDNZDm

         swap_direction = 0;
                           Message = "new alert AUDNZD ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDNZDm  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
      }
      else {

         swap_direction = 1;
                           Message = "new alert UNKNOWN PAIR ";
Comment("\n"," --***--TREND CHASER PSAR--***--UNKNOWN PAIR  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
      }
   }
 if (comments&&normal_account){                               //FGBPJPYm 
        if (Symbol()=="GBPJPY"){

                                    swap_direction = 2;
                                    Message = "new alert GBPJPY ";
                                    



Comment("\n"," --***--TREND CHASER PSAR--***--GBPJPY  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",

"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
      }   
      else if (Symbol()=="GBPUSD"){                                 //FGBPUSDm

                                 swap_direction = 2;
                                                                  Message = "new alert GBPUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--GBPUSD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",

"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
               }   
      else if (Symbol()=="EURUSD"){                     //FEURUSDm

         swap_direction = 0;
                  Message = "new alert EURUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURUSD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                        }   
      else if (Symbol()=="USDJPY"){                     //FUSDJPYm

         swap_direction = 2;
                  Message = "new alert USDJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--USDJPY  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="USDCHF"){                          //FUSDCHFm

         swap_direction = 2;
                  Message = "new alert USDCHF ";
Comment("\n"," --***--TREND CHASER PSAR--***--USDCHF  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURCHF"){                              //FEURCHFm

         swap_direction = 2;
                  Message = "new alert EURCHF ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURCHF  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDUSD"){                        //FAUDUSDm

         swap_direction = 2;
                  Message = "new alert AUDUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDUSD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="USDCAD"){                    //FUSDCADm

         swap_direction = 2;
                  Message = "new alert USDCAD ";
Comment("\n"," --***--TREND CHASER PSAR--***--USDCAD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="NZDUSD"){                  //FNZDUSDm

         swap_direction = 2;
                  Message = "new alert NZDUSD ";
Comment("\n"," --***--TREND CHASER PSAR--***--NZDUSD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURGBP"){                       //FEURGBPm

         swap_direction = 0;
                  Message = "new alert EURGBP ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURGBP  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURJPY"){                         //FEURJPYm

         swap_direction = 2;
                  Message = "new alert EURJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURJPY  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="CHFJPY"){                           //FCHFJPYm

         swap_direction = 2;
                  Message = "new alert CHFJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--CHFJPY  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="GBPCHF"){                     //FGBPCHFm

         swap_direction = 2;
                  Message = "new alert GBPCHF ";
Comment("\n"," --***--TREND CHASER PSAR--***--GBPCHF  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURAUD"){                       //FEURAUDm

         swap_direction = 0;
                  Message = "new alert EURAUD "; 
Comment("\n"," --***--TREND CHASER PSAR--***--EURAUD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="EURCAD"){                            //FEURCADm

         swap_direction = 0;
                  Message = "new alert EURCAD ";
Comment("\n"," --***--TREND CHASER PSAR--***--EURCAD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDCAD"){                        //FAUDCADm

         swap_direction = 2;
                  Message = "new alert AUDCAD ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDCAD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDJPY"){                        //FAUDJPYm

         swap_direction = 2;
                  Message = "new alert AUDJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDJPY  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="NZDJPY"){                        //FNZDJPYm

         swap_direction = 2;
                           Message = "new alert FNZDJPY ";
Comment("\n"," --***--TREND CHASER PSAR--***--NZDJPY  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
                                 }   
      else if (Symbol()=="AUDNZD"){                         //FAUDNZDm

         swap_direction = 0;
                           Message = "new alert AUDNZD ";
Comment("\n"," --***--TREND CHASER PSAR--***--AUDNZD  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
      }
      else {

         swap_direction = 1;
                           Message = "new alert UNKNOWN PAIR ";
Comment("\n"," --***--TREND CHASER PSAR--***--unknown pair  period ", Period(),(""),
"\n",
"\n","     auto psar settings= ",(automode),
"\n","     entry mode= ",(mode),
"\n","     tick mode= ",(tick_mode),
"\n",
"\n","     ind used for entry= ",(mode_for_entry),
"\n","     ind used for exit= ",(mode_for_exit),
"\n",
"\n","     psar= ",DoubleToStr(psar,5),//max = 0.011;
"     max= ",DoubleToStr(max,5),
"     period= ",DoubleToStr(time_frame_for_signal,0),
"\n",
 
"\n","     sell loss= ",DoubleToStr(StopLoss,0),
"     take profit= ",DoubleToStr(TakeProfit,0),
"     trailing stop= ",DoubleToStr(TrailingStop,0),
"     Break Even= ",DoubleToStr(BreakEven,0),
"\n",
"\n","     envelope period buy= ",DoubleToStr(envelopes_period_buy,0),"     buy= ",DoubleToStr(buy,2),
"     close buy= ",DoubleToStr(close_buy,2),//max = 0.011;
"\n","     envelope period sell= ",DoubleToStr(envelopes_period_sell,0),"     sell= ",DoubleToStr(sell,2),
"     close sell= ",DoubleToStr(close_sell,2),//max = 0.011;
"     period= ",DoubleToStr(time_frame_for_env,0),
"\n",
"\n","     Broker time= ",TimeToStr(TimeCurrent()),
"\n","     MagicNumber= ",DoubleToStr(MagicNumber,0));
      }
   }
   int Order = SIGNAL_NONE;
   int Total, Ticket, MagicNumber;
   double StopLossLevel, TakeProfitLevel;
   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
   double bec = iClose(NULL, 0, Current + 0);
double be = iEnvelopes(NULL, time_frame_for_env, envelopes_period_buy, MODE_SMMA, 0, PRICE_MEDIAN, buy, MODE_LOWER, Current + 0);
double bec2 = iClose(NULL, 0, Current + 1);
double be2 = iEnvelopes(NULL, time_frame_for_env, envelopes_period_buy, MODE_SMMA, 0, PRICE_MEDIAN, buy, MODE_LOWER, Current + 1);
double bec3 = iClose(NULL, 0, Current + 2);
double be3 = iEnvelopes(NULL, time_frame_for_env, envelopes_period_buy, MODE_SMMA, 0, PRICE_MEDIAN, buy, MODE_LOWER, Current + 2);
   
double bsar = iSAR(NULL, time_frame_for_signal, psar, max, Current + 0);
double bsarc = iClose(NULL, 0, Current + 0);
double bsar2 = iSAR(NULL, time_frame_for_signal, psar, max, Current + 1);
double bsarc2 = iClose(NULL, 0, Current + 1);
double bsar3 = iSAR(NULL, time_frame_for_signal, psar, max, Current + 2);
double bsarc3 = iClose(NULL, 0, Current + 2);
double bmac = iClose(NULL, 0, Current + 0);
double bma = iMA(NULL, time_frame_for_signal, ma, 0, MODE_SMMA, PRICE_OPEN, Current + 0);
double bmac2 = iClose(NULL, 0, Current + 1);
double bma2 = iMA(NULL, time_frame_for_signal, ma, 0, MODE_SMMA, PRICE_OPEN, Current + 1);
double bmac3 = iClose(NULL, 0, Current + 2);
double bma3 = iMA(NULL, time_frame_for_signal, ma, 0, MODE_SMMA, PRICE_OPEN, Current + 2);

double ssar = iSAR(NULL, time_frame_for_signal, psar, max, Current + 0);
double ssarc = iClose(NULL, 0, Current + 0);
double ssar2 = iSAR(NULL, time_frame_for_signal, psar, max, Current + 1);
double ssarc2 = iClose(NULL, 0, Current + 1);
double ssar3 = iSAR(NULL, time_frame_for_signal, psar, max, Current + 2);
double ssarc3 = iClose(NULL, 0, Current + 2);

   double sec = iClose(NULL, 0, Current + 0);
double se = iEnvelopes(NULL, time_frame_for_env, envelopes_period_sell, MODE_SMMA, 0, PRICE_MEDIAN, sell, MODE_UPPER, Current + 0);
double sec2 = iClose(NULL, 0, Current + 1);
double se2 = iEnvelopes(NULL, time_frame_for_env, envelopes_period_sell, MODE_SMMA, 0, PRICE_MEDIAN, sell, MODE_UPPER, Current + 1);
double sec3 = iClose(NULL, 0, Current + 2);
double se3 = iEnvelopes(NULL, time_frame_for_env, envelopes_period_sell, MODE_SMMA, 0, PRICE_MEDIAN, sell, MODE_UPPER, Current + 2);


double smac = iClose(NULL, 0, Current + 0);
double sma = iMA(NULL, time_frame_for_signal, ma, 0, MODE_SMMA, PRICE_OPEN, Current + 0);
double smac2 = iClose(NULL, 0, Current + 1);
double sma2 = iMA(NULL, time_frame_for_signal, ma, 0, MODE_SMMA, PRICE_OPEN, Current + 1);
double smac3 = iClose(NULL, 0, Current + 2);
double sma3 = iMA(NULL, time_frame_for_signal, ma, 0, MODE_SMMA, PRICE_OPEN, Current + 2);

   double Close_bec = iClose(NULL, 0, Current + 0);
double Close_be = iEnvelopes(NULL, time_frame_for_env, envelopes_period_buy, MODE_SMMA, 0, PRICE_MEDIAN, close_buy, MODE_UPPER, Current + 0);
double Close_bsar = iSAR(NULL, time_frame_for_signal, psar, max, Current + 0);
double Close_bsarc = iClose(NULL, 0, Current + 0);

   double Close_sec = iClose(NULL, 0, Current + 0);
double Close_se = iEnvelopes(NULL, time_frame_for_env, envelopes_period_sell, MODE_SMMA, 0, PRICE_MEDIAN, close_sell, MODE_LOWER, Current + 0);
double Close_ssar = iSAR(NULL, time_frame_for_signal, psar, max, Current + 0);
double Close_ssarc = iClose(NULL, 0, Current + 0);
   bool IsTrade = False;
   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == MagicNumber)
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {        
   if (OrderMagicNumber() == MagicNumber)
 
      if (close_with_envelopes&&close_with_psar&&OrderMagicNumber() == MagicNumber&&ITradedOnThisBar != Bars){
                    if (Close_bec > Close_be||Close_bsarc < Close_bsar) Order = SIGNAL_CLOSEBUY;
                     else
     {
     }
   }
   if (close_with_envelopes==false&&close_with_psar&&OrderMagicNumber() == MagicNumber&&ITradedOnThisBar != Bars){

                     if (Close_bsarc < Close_bsar) Order = SIGNAL_CLOSEBUY;
                     else
     {
     }
   }
         if (close_with_envelopes&&close_with_psar==false&&OrderMagicNumber() == MagicNumber&&ITradedOnThisBar != Bars){

                    if (Close_bec > Close_be) Order = SIGNAL_CLOSEBUY;
                     else
     {
     }
   }

     

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, 200, MediumSeaGreen);
               if (email_notification) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               if (Use_Sound_only) PlaySound(NameFileSound);
               if (Use_popup_and_sound_alert) Alert(Message);
               IsTrade = False;
               continue;
            }
            if(True && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
   
   if (close_with_envelopes&&close_with_psar&&OrderMagicNumber() == MagicNumber&&ITradedOnThisBar != Bars){

                     if (Close_sec < Close_se||Close_ssarc > Close_ssar) Order = SIGNAL_CLOSESELL;
                     else
     {
     }
   }
   if (close_with_envelopes==false&&close_with_psar&&OrderMagicNumber() == MagicNumber&&ITradedOnThisBar != Bars){

                     if (Close_ssarc > Close_ssar) Order = SIGNAL_CLOSESELL;
                     else
     {
     }
   }
      if (close_with_envelopes&&close_with_psar==false&&OrderMagicNumber() == MagicNumber&&ITradedOnThisBar != Bars){
 
                     if (Close_sec < Close_se) Order = SIGNAL_CLOSESELL;
                     else
     {
     }
   }
            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, 200, DarkOrange);
               if (email_notification) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               if (Use_Sound_only) PlaySound(NameFileSound);
               if (Use_popup_and_sound_alert) Alert(Message);
               IsTrade = False;
               continue;
            }
            if(True && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }  
      datetime tLastLongEntry = Time[1];
datetime tLastShortEntry = Time[1];
    if (open_with_psar==False&&open_with_envelopes&&trade_at_cross_only&&enter_at_ma==False&&ITradedOnThisBar != Bars){
   if (bec < be  && bec2 >= be2 && tLastLongEntry < Time[0]) Order = SIGNAL_BUY;
   if (sec > se && sec2 <= se2 && tLastShortEntry < Time[0]) Order = SIGNAL_SELL;
   else
     {
     }
   }
       if (open_with_psar==False&&open_with_envelopes&&enter_at_ma&&trade_at_cross_only==False&&normal_entry==False&&ITradedOnThisBar != Bars){
         if (bec < be&&bmac < bma) Order = SIGNAL_BUY;
   if (sec > se&&smac > sma) Order = SIGNAL_SELL;
   else
     {
     }
   }
   ///////////////////



      if (open_with_psar==False&&open_with_envelopes&&trade_at_cross_only==False&&enter_at_ma==False&&ITradedOnThisBar != Bars){
      
         if (bec < be) Order = SIGNAL_BUY;
   if (sec > se) Order = SIGNAL_SELL;
   else
     {
     }
   }
////////////////////////////////////////////////////////////////////////////////////////////////////
    if (open_with_psar&&open_with_envelopes&&trade_at_cross_only&&enter_at_ma==False&&ITradedOnThisBar != Bars){
   
   if (bec < be&&bsarc > bsar&&bec2 < be2  && bec3 >= be3 && tLastLongEntry < Time[0]) Order = SIGNAL_BUY;
   if (ssarc < ssar&&sec > se&&sec2 > se2 && sec3 <= se3 && tLastShortEntry < Time[0]) Order = SIGNAL_SELL;
    else
     {
     }
   }
       if (open_with_psar&&open_with_envelopes&&enter_at_ma&&trade_at_cross_only==False&&normal_entry==False&&ITradedOnThisBar != Bars){
      
         if (bec < be&&bsarc > bsar&&bmac < bma) Order = SIGNAL_BUY;
   if (sec > se&&ssarc < ssar&&smac > sma) Order = SIGNAL_SELL;
   else
     {
     }
   }
   ///////////////////
    if (open_with_psar&&open_with_envelopes==False&&trade_at_cross_only&&enter_at_ma==False&&ITradedOnThisBar != Bars){
   
   if (bsarc > bsar  && bsarc2 <= bsar2 && tLastLongEntry < Time[0]) Order = SIGNAL_BUY;
   if (ssarc < ssar && ssarc2 >= ssar2 && tLastShortEntry < Time[0]) Order = SIGNAL_SELL;
   else
     {
     }
   }
       if (open_with_psar&&open_with_envelopes==False&&enter_at_ma&&trade_at_cross_only==False&&normal_entry==False&&ITradedOnThisBar != Bars){
      
         if (bsarc > bsar&&bmac < bma) Order = SIGNAL_BUY;
   if (ssarc < ssar&&smac > sma) Order = SIGNAL_SELL;
   else
     {
     }
   }
   if (open_with_psar&&open_with_envelopes==False&&trade_at_cross_only==False&&enter_at_ma==False&&ITradedOnThisBar != Bars){
  
         if (bsarc > bsar) Order = SIGNAL_BUY;
   if (ssarc < ssar) Order = SIGNAL_SELL;
   else
     {
     }
   }
      if (open_with_psar&&open_with_envelopes&&trade_at_cross_only==False&&enter_at_ma==False&&ITradedOnThisBar != Bars){
    
         if (bec < be&&bsarc > bsar) Order = SIGNAL_BUY;
   if (sec > se&&ssarc < ssar) Order = SIGNAL_SELL;
   else
     {
     }
   }
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (0 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         if (TRUE) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (True) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;
         Ticket = OrderSend(Symbol(), OP_BUY,LotsOptimized(), Ask, 200, StopLossLevel, TakeProfitLevel, "Buy(trendchaser_psar   " + MagicNumber  + ")", MagicNumber, 236, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (email_notification) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
                if (Use_Sound_only) PlaySound(NameFileSound);
                if (Use_popup_and_sound_alert) Alert(Message);
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         if (AccountFreeMargin() < (0 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         if (True) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (True) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;
         Ticket = OrderSend(Symbol(), OP_SELL,LotsOptimized(), Bid, 200, StopLossLevel, TakeProfitLevel, "Sell(trendchaser_psar   " + MagicNumber  + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {               
				Print("SELL order opened : ", OrderOpenPrice());
                if (email_notification) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
                if (Use_Sound_only) PlaySound(NameFileSound);
                if (Use_popup_and_sound_alert) Alert(Message);
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }
   if (!EachTickMode) BarCount = Bars;
   return(0);
}